﻿#pragma once
#include <vector>
#include <string>
#include <iostream>
using namespace std;
 




//*******************************************************
struct LineEqu
{
	double a, b;

};
//*******************************************************
struct ParabolaEqu
{
	double A, B, C;
};
//*******************************************************
struct pointcor
{
	double xcor;
	double ycor;
};
//*******************************************************
struct boundary
{
	pointcor upperl, upperr, lowerl, lowerr, leftl, leftu, rightl, rightu;
};

//*******************************************************
struct linesegment
{
	double xpo1, ypo1, xpo2, ypo2;
};
//*******************************************************
struct tempIndex
{
	pointcor tempcenter;
	double templength;
	double vertdis;
	int orignalFractureIndex;
	linesegment line;
};
//*******************************************************
class FractalNetwork
{
public:
	struct myclass {
		bool operator() (pointcor pt1, pointcor pt2)// compare two points based on the x-coordinates
		{
			return (pt1.xcor < pt2.xcor) || ((pt1.xcor == pt2.xcor) && (pt1.ycor < pt2.ycor));
		}
	} myobject;

	//****************************************** 
	struct myclass1 {
		bool operator() (linesegment pt1, linesegment pt2) // compare two line segments based on the x-coordinates
		{ 
			return(pt1.xpo1 < pt2.xpo1) || ((pt1.xpo1 == pt2.xpo1) && (pt1.xpo2 < pt2.xpo2));// sort fractures based on the x coordinates
		}
	} myobject3;
	//******************************************
	struct myclass2 {
		bool operator() (tempIndex pt1, tempIndex pt2)
		{
			return(pt1.vertdis > pt2.vertdis) || ((pt1.vertdis == pt2.vertdis) && (pt1.templength > pt2.templength));// sort tempIndex based on the verticle length, if the vertical length is the same, we will sort by covered length
		}
	} Indexcompare;
	//******************************************
	struct myclass3 {
		bool operator() (double a, double b)
		{
			return(a>b);// sort tempIndex based on the verticle length, if the vertical length is the same, we will sort by covered length
		}
	} doublecompare;
	//******************************************
	struct myclass4 {
		bool operator() (linesegment pt1, linesegment pt2)
		{
			return(pt1.ypo1 > pt2.ypo1) || ((pt1.ypo1 == pt2.ypo1) && (pt1.xpo1 < pt2.xpo1));// sort fractures based on the y coordinates, if y coordinates are the same, check the xpo1 coordinates
		}
	} linecompare;

	//******************************************
	FractalNetwork() {} // constructor: initialization
	~FractalNetwork() {}  //deconstructor
	//******************************************
	// variables
	const double PI = 3.14159265359;
	const double tol = 1e-10;
	const double NN = 99999999999;
	int L;//system size;
	int bs; //block size;
	int BN;//blocknumber;
	linesegment Fracture;
	int *xcord; // 1D vector to record the coordinates on the x-axis
	int *ycord; // 1D vector to record the coordinates on the y-axis
	int FractureNum;
	int capacity; // to assigan space for arrays.
	double *Angle; // 1D vector to record angles
	double *Length; 
	pointcor *Position;
	linesegment *Fractures;
	int *Fractureblock;
	int** Allblocknumber;// record the fracture indexes in each block;
	int *k;// record the fracture number in each block
	pointcor** AllFractureIntersect;// record the intersection points of each fracture;
	int *m; // record how many intersections each fracture has;
	int * tempIntersectBlock;// record the temporary intersecting fractures for one fracture; 
	tempIndex* tempindex;
	tempIndex *Preindex;// 1D vector, to record the intersection points of linesegments and the circle;
	int countTempIndex;
	bool** segmentcovered; // each item has two elements, segmentcovered[i][0] and segmentcovered[i][0] record the covered status of ith segment.
	double *lastradius;
	pointcor** centers;
	double *radius;
	int *countCenters;
	int *tempFracturesindex;
	linesegment* ExtraFractures;
	int countExtraFracture;
	linesegment* totalfractures;
	int counttotalfractures;
	/**************************************************************************************************************************/
 

	// functions
	void  Calculate_Fractal(FractalNetwork mynetwork);
	void AssignCapacity(int outtercapacity, int outterL, int outterbs);
	double Calculate_compass_fractal(string name, double r, double rmax, int iteration);
	double secentlength(pointcor center, double r, linesegment line);
	void  Outputarray(string name, int num, double *array);
	int InputFracture(string filename, double &xmax, double &xmin, double &ymax, double &ymin, int &largestlengthindex, double &totallength);
	double CalAngle(linesegment line);
	double CalAngle(pointcor p1, pointcor p2);
	bool AllpreviousIncluded(pointcor center, double r, tempIndex previous, int num);
	bool check_line_circle_relation(pointcor center, double r, linesegment line, pointcor intersect1, pointcor intersect2, int Fnum, int &totalnum, int iter, int &totalnum3);
	void checkvalid(pointcor newpoint, linesegment line1, linesegment line2, int Fnum, double r);
	bool CheckPointInsideLineSegement(pointcor point, linesegment line);
	double min(double x, double y);
	double max(double x, double y);
	void transformFractures(int num, double angle, double &xmax, double &xmin, double &ymax, double &ymin);
	pointcor Translate2D(pointcor &point, double px, double py);
	double LengthCal(linesegment linex);
	int  Generatexycord(int L, int bs, int *xcord, int *ycord);
	void BlockIndex(int** Allblocknumber, int FractureNum, int &Nblock, int n);
	void reassign(int num1, int*array1);
	void reassign(int num1, int num2, bool**array1);
	int singleloop;
	pointcor pol2cart(double th, double r);
	double LengthCal(pointcor p1, pointcor p2);
	pointcor FindNextCenter(tempIndex*Preindex, int num, double r, double xmin, double xmax, double ymin, double ymax, double n, int iter);
	void  Outputcircles(int num, double r, string name);
	double Circle_Line_intersect(pointcor center, double r, linesegment line, pointcor& intersect1, pointcor& intersect2);
	double dotproduct(pointcor p1, pointcor p2);
	bool pointIncircle(pointcor center, double r, pointcor p);
	double dotTolineDis(pointcor center, linesegment line);
	int Findfirstmax(int *xcord, double x, int n);
	int BinaryFindfirstmax(double x, int *vec, int p1, int p2);
	int Findlastmin(int *xcord, double x, int n);
	int BinaryFindlastmin(double x, int *vec, int p1, int p2);
	bool Iszero(double d);
	bool Iszero(int d);
	int Generatexycord(int L, int bs, int * xcord, int *ycord, int xmin, int ymin);
	void BlockIndex(int** Allblocknumber, int &Nblock, int n, linesegment Fracture);
	void rotate2D(linesegment &line, double theta, pointcor centerpoint);
	void rotate2D(pointcor &point, double sintheta, double costheta, pointcor centerpoint);
	int RemoveDuplicate(int a[], int size);
	void Translate2D(linesegment &line, double px, double py);
	linesegment Translate2D(linesegment line, double px, double py, double n);
	pointcor SolveQua(double A, double B, double C);
	int RemoveDuplicate(linesegment a[], int size);
	void OutputFracture(string name, int num, linesegment* fractures);
	int InputFracture(string filename, double &totallength);
	int InputCenter(string filename, double r, pointcor *centers);
	void Iinputstring(string& name);
 };

 

















