%% this part is to plot the real fault maps and rescale the realfault maps to [0,10];
close all;clear
load([cd,'\Data\RealFaults.mat'])
n=size(FaultSegments,2);
scalelength=[2000 5000 10000]
for i=1:3
    x=FaultSegments{i}
    x=[x(1:2:end-1,:),x(2:2:end,:)]
    [X,Y] = LinesToXYnan2D(x);
    dx=max( max(Y(1,:)), max(X(1,:)) )-min( min(Y(1,:)), min(X(1,:)) )
    dy=max( max(Y(2,:)), max(X(2,:)) )-min( min(Y(2,:)), min(X(2,:)) )
    L=max(dx,dy)
    x=10*x./L;
    x=x -min(min(x));
    [X,Y] = LinesToXYnan2D(x);
    figure
    hold on
    plot(X,Y,'-','color','red','linewidth',1.5);
    axis off
    axis equal;
    set(gcf,'color',[1 1 1])
    reallength=Lengths2D(x(end,:));
    scale(i)=scalelength(i)/reallength;
    totallength=sum(Lengths2D(x(1:end-1,:)))*scale(i)/(size(x,1)-1)
end
% for generated faults, they have the same scale 1000;
scale(4:20)=1000;
%% plot the fault segments
% close all
% you should change the file name to plot different fault map
name='generated3'
path=[cd,'\Data\Results'];
radius=load([path,'\radius_',name,'.txt']);
numcircle =load([path,'\Numcircles_',name,'.txt'])
Fracture=load([path,'\',name,'_changed.txt']);
figure
[X,Y] = LinesToXYnan2D(Fracture);% get the coordinate of every fracture;
Num=size(Fracture,1)
hold on
for i = 1:Num
    plot(X(:,i),Y(:,i),'color','r','linewidth',1);
    hold on
end
ylim([0 20])
axis off
grid off
%% before running the following code, you should generate corresponding data through run FractureNetwork.exe.
% choose a radius to plot the line segments covered by circles;
for ii=37
    a=load([path,'\',name,'_circle_',num2str(radius(ii)),'.txt']);
    r=radius(ii);
    n=size(a,1);
    for i=1:n
        rectangle('Position',[a(i,1)-r,a(i,2)-r,2*r,2*r],'Curvature',[1,1])
        hold on
    end
    axis equal
end
%% this part is to plot the fractal curve of real fault maps
radius=load([path,'\radius_RealFault1.txt']);
numcircle =load([path,'\Numcircles_RealFault1.txt']);
radius=scale(1)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 4;
ytickformat('%,.2f')
% grid on 
box on
%% Real fault 2
radius=load([path,'\radius_RealFault2.txt']);
numcircle =load([path,'\Numcircles_RealFault2.txt']);
radius=scale(2)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 4;
ytickformat('%,.1f')
% grid on 
box on
%% Real fault 3
radius=load([path,'\radius_RealFault3.txt']);
numcircle =load([path,'\Numcircles_RealFault3.txt']);
radius=scale(3)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 5;
ytickformat('%,.1f')
% grid on 
box on
%% generated map 1
% close all
radius=load([path,'\radius_generated1.txt']);
numcircle =load([path,'\Numcircles_generated1.txt']);
radius=scale(4)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 4;
ytickformat('%,.1f')
xlim([0.1,1000])
% grid on 
box on
%% generated map 2
% close all
radius=load([path,'\radius_generated2.txt']);
numcircle =load([path,'\Numcircles_generated2.txt']);
radius=scale(5)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 4;
ytickformat('%,.2f')
% grid on 
box on
%% generated map 3
close all
radius=load([path,'\radius_generated3.txt']);
numcircle =load([path,'\Numcircles_generated3.txt']);4
radius=scale(4)*radius;
figure
logr=log(radius);
loglength=log(numcircle.*2.*radius);
loglog(exp(logr),exp(loglength),'o','color','r');
xlabel('$$\mathrm{Radius~of~Circle,~} r,(m)$$', 'interpreter', 'latex','fontsize',16)
ylabel('$$\mathrm{Length~of~Line~Segments,~} L(r),(m)$$', 'interpreter', 'latex','fontsize',16)
ax = gca;
ax.YAxis.Exponent = 4;
ytickformat('%,.2f')
% grid on 
box on
